/*
	zɂ`Xgitj
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define Null  -1			/* CfbNX */

typedef enum {
	Term, Insert, Append, Delete, Clear, Print, Print1, Print2
} Menu;

typedef int  Index;		/* CfbNX^ */

/* ԍCfbNX */
typedef struct {
	int   no;
	Index ptr;
} key1;

/* OCfbNX */
typedef struct {
	char  name[10];
	Index ptr;
} key2;

/*--- vf ---*/
typedef struct {
	int   no;			/* ԍ */
	char  name[10];		/* O */
	Index next;			/* ̗vf̃CfbNX */
	Index Dnext;		/* 폜Xg|C^ */
} Node;

/*--- `Xg ---*/
typedef struct {
	Node  *n;			/* Xg{́izj */
	Index top;			/* Xg̐擪vf̃CfbNX */
	Index max;			/* pR[h̍őCfbNX */
	Index deleted;		/* 폜Xg̐擪vf̃CfbNX */
	Index max2;		/* ݓo^Ă郌R[h */
	key1  *idx1;		/* ԍCfbNXe[u */
	key2  *idx2;		/* OCfbNXe[u */
} List;

#define Top     (list->top)				/* Xg̐擪 */

#define Second  (list->n[Top].next)		/* XĝQԖ */

#define Next(x) (list->n[(x)].next)		/* xR[h̗̎vf */

/*--- ԍCfbNXe[u̒T ---*/
int Search1(List *list, int no, Index *flag)
{
	int i = 0;
	int j = list->max2 - 1;

	if (j == -1) {							/* Xg */
		*flag = 0;
		return 0;
	}

	do {									/* QTɂT */
		int k = (i + j) / 2;
		int cmp = no - list->idx1[k].no;
		if (!cmp) {
			*flag = k;
			return 1;
		} else if (cmp > 0)
			i = k + 1;
		else
			j = k - 1;
	} while (i <= j);
	*flag = i;

	return 0;
}

/*--- OCfbNXe[u̒T ---*/
int Search2(List *list, const char *name, Index *flag)
{
	int i = 0;
	int j = list->max2 - 1;

	if (j == -1) {							/* Xg */
		*flag = 0;
		return 0;
	}

	do {									/* QTɂT */
		int k = (i + j) / 2;
		int cmp = strcmp(name, list->idx2[k].name);
		if (!cmp) {
			*flag = k;
			return 1;
		} else if (cmp > 0)
			i = k + 1;
		else
			j = k - 1;
	} while (i <= j);
	*flag = i;

	return 0;
}

/*---- }ɂCfbNXe[u̍XV ----*/
void Apnd(List *list, int no, const char *name, Index rec)
{
	Index i;
	Index idx;

	Search1(list, no, &idx);					/*--- ԍ ---*/
	for (i = list->max2; i > idx; i--)
		list->idx1[i] = list->idx1[i - 1];
	list->idx1[idx].no	= list->n[rec].no;
	list->idx1[idx].ptr = rec;

	Search2(list, name, &idx);					/*--- O ---*/
	for (i = list->max2; i > idx; i--)
		list->idx2[i] = list->idx2[i - 1];
	strcpy(list->idx2[idx].name, list->n[rec].name);
	list->idx2[idx].ptr = rec;

	list->max2++;
}

/*---- XgrecR[h폜 ----*/
void Delt(List *list, Index rec)
{
	Index i;

	for (i = 0; list->idx1[i].ptr != rec; i++)	/*--- ԍ ---*/
		;
	for ( ; i < list->max2; i++)
		list->idx1[i] = list->idx1[i + 1];

	for (i = 0; list->idx2[i].ptr != rec; i++)	/*--- O ---*/
		;
	for ( ; i < list->max2; i++)
		list->idx2[i] = list->idx2[i + 1];

	list->max2--;
}

/*--- }ׂR[h̃CfbNXԂ ---*/
int GetIndex(List *list)
{
	if (list->deleted == Null)			/* 폜R[hȂꍇ */
		return ++(list->max);
	else {
		Index rec = list->deleted;
		list->deleted = list->n[rec].Dnext;
		return rec;
	}
}

/*--- w肵R[h폜Xgɓo^ ---*/
void DeleteIndex(List *list, Index idx)
{
	if (list->deleted == Null) {			/* 폜R[hȂꍇ */
		list->deleted = idx;
		list->n[idx].Dnext = Null;
	} else {
		Index ptr = list->deleted;
		list->deleted = idx;
		list->n[idx].Dnext = ptr;
	}
}

/*--- vf̊eoɒlݒ ----*/
void SetNode(Node *x, int no, const char *name, Index next)
{
	x->no   = no;
	x->next = next;
	strcpy(x->name, name);
}

/*--- 擪ɗvf} ---*/
void InsertNode(List *list, int no, const char *name)
{
	Index ptr = Top;

	Top = GetIndex(list);
	SetNode(&list->n[Top], no, name, ptr);
	Apnd(list, no, name, Top);
}

/*--- ɗvfǉ ----*/
void AppendNode(List *list, int no, const char *name)
{
	if (Top == Null)							/* Xgł */
		InsertNode(list, no, name);				/* 擪ɑ} */
	else {
		Index ptr = Top;
		while (Next(ptr) != Null)				/* m[h */
			ptr = Next(ptr);
		Next(ptr) = GetIndex(list);
		SetNode(&list->n[Next(ptr)], no, name, Null);
		Apnd(list, no, name, Next(ptr));
	}
}

/*--- 擪̗vf폜 ---*/
void DeleteNode(List *list)
{
	if (Top != Null) {							/* XgłȂ */
		Index ptr = Second;
		DeleteIndex(list, Top);
		Delt(list, Top);
		Top = ptr;
	}
}

/*--- ׂĂ̗vf폜 ---*/
void ClearList(List *list)
{
	while (Top != Null)						/* XgɂȂ܂ */
		DeleteNode(list);					/* 擪m[h폜 */
}

/*--- ׂĂ̗vf\iXgj ---*/
void PrintList(const List *list)
{
	Index ptr = Top;

	puts("yꗗ\z");
	while (ptr != Null) {
		printf("%5d %-10.10s\n", list->n[ptr].no, list->n[ptr].name);
		ptr = Next(ptr);
	}
}

/*--- ׂĂ̗vf\iԍj ---*/
void PrintList1(const List *list)
{
	Index i;

	puts("yꗗ\^ԍz");
	for (i = 0; i < list->max2; i++) {
		Index j = list->idx1[i].ptr;
		printf("%5d %-10.10s\n", list->n[j].no, list->n[j].name);
	}
}

/*--- ׂĂ̗vf\iOj ---*/
void PrintList2(const List *list)
{
	Index i;

	puts("yꗗ\^Oz");
	for (i = 0; i < list->max2; i++) {
		Index j = list->idx2[i].ptr;
		printf("%5d %-10.10s\n", list->n[j].no, list->n[j].name);
	}
}

/*--- `Xg̏ ---*/
void InitList(List *list, int size)
{
	list->n    = calloc(size, sizeof(Node));	/* Xg{ */
	list->idx1 = calloc(size, sizeof(key1));	/* ԍXg */
	list->idx2 = calloc(size, sizeof(key2));	/* OXg */

	list->max2 = 0;
	list->top  = list->max = list->deleted = Null;
}

/*--- `Xǧn ---*/
void TermList(List *list)
{
	ClearList(list);				/* ׂẴm[h폜 */

	free(list->n);
	free(list->idx1);
	free(list->idx2);
}

/*--- f[^̓ ---*/
Node Read(const char *message)
{
	Node temp;

	printf("%sf[^͂ĂB\n", message);

	printf("ԍF");   scanf("%d", &temp.no);
	printf("OF");   scanf("%s", temp.name);

	return temp;
}

/*--- j[I ---*/
Menu SelectMenu(void)
{
	int ch;

	do {
		printf("\n(1) 擪ɗvf}     (2)ɗvfǉ\n");
		printf("(3) 擪̗vf폜     (4)ׂĂ̗vf폜\n");
		printf("(5) Svf\(Xg)\n");
		printf("(6) Svf\(  )\n");
		printf("(7) Svf\( O )\n");
		printf("(0)       I  @@ F");
		scanf("%d", &ch);
	} while (ch < Term || ch > Print2);

	return (Menu)ch;
}

/*--- C ---*/
int main(void)
{
	Menu menu;
	List list;

	InitList(&list, 100);		/* őm[h100 */

	do {
		Node x;
		switch (menu = SelectMenu()) {
		 case Insert: x = Read("擪ɑ}");
					  InsertNode(&list, x.no, x.name);
					  break;
		 case Append: x = Read("ɒǉ");
					  AppendNode(&list, x.no, x.name);
					  break;
		 case Delete: DeleteNode(&list);
					  break;
		 case Clear : ClearList(&list);
					  break;
		 case Print : PrintList(&list);
					  break;
		 case Print1: PrintList1(&list);
					  break;
		 case Print2: PrintList2(&list);
					  break;
		}
	} while (menu != Term);

	TermList(&list);			/* `Xg̗pI */

	return 0;
}
