/*
	R\[ʂ̕FEwiFݒ "setcolor.c"
*/

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>

#include "display.h"

/*--- F̕ ---*/
char *color_str[] = {
	"BLACK", "BLUE", "RED", "GREEN", "MAGENTA", "CYAN", "YELLOW", "WHITE",
	"GRAY", "BRIGHT_BLUE", "BRIGHT_RED", "BRIGHT_GREEN", "BRIGHT_MAGENTA",
	"BRIGHT_CYAN", "BRIGHT_YELLOW", "BRIGHT_WHITE"
};

/*--- ri啶EʂȂj ---*/
int strcmpx(const char *s1, const char *s2)
{
	while (toupper(*s1) == toupper(*s2)) {
		if (*s1 == '\0')			/*  */
			return 0;
		s1++;
		s2++;
	}
	return toupper((unsigned char)*s1) - toupper((unsigned char)*s2);
}

/*--- F̕R[hɕϊ ---*/
int get_color(char *str)
{
	int i;

	for (i = 0; i < sizeof(color_str) / sizeof(color_str[0]); i++)
		if (!strcmpx(str, color_str[i]))
			return i;
	return -1;				/* YF͂Ȃ */
}

/*--- G[bZ[WƎg\ċI ---*/
void error(int code)
{
	switch (code) {
	 case 1: fprintf(stderr, "FEwiFw肵ĂB\n"); break;
	 case 2: fprintf(stderr, "F̎w肪܂B\n");	  break;
	 case 3: fprintf(stderr, "wiF̎w肪܂B\n");	  break;
	}
	fprintf(stderr, "---------------------------------------\n");
	fprintf(stderr, "SETCOLOR F [wiF]\n");
	fprintf(stderr, "---------------------------------------\n");
	fprintf(stderr, "Fɂ͈ȉɎ16FA\n");
	fprintf(stderr, "wiFɂ͍8Fw肵ĂB\n");
	fprintf(stderr, "wiFȗƍƂ݂Ȃ܂B\n");
	fprintf(stderr, "---------------------------------------\n");
	fprintf(stderr, "BLACK        GRAY\n");
	fprintf(stderr, "BLUE         BRIGHT_BLUE\n");
	fprintf(stderr, "RED          BRIGHT_RED\n");
	fprintf(stderr, "GREEN        BRIGHT_GREEN\n");
	fprintf(stderr, "MAGENTA      BRIGHT_MAGENTA\n");
	fprintf(stderr, "CYAN         BRIGHT_CYAN\n");
	fprintf(stderr, "YELLOW       BRIGHT_YELLOW\n");
	fprintf(stderr, "WHITE        BRIGHT_WHITE\n");

	exit(1);					/* I */
}

int main(int argc, char *argv[])
{
	int fg;				/* F */
	int bg = BLACK;		/* wiF */

	if (argc < 2)		/* FwiFw肳ĂȂ */
		error(1);
	if (argc >= 2)
		if ((fg = get_color(argv[1])) == -1) error(2);
	if (argc >= 3)
		if ((bg = get_color(argv[2])) == -1) error(3);

	colorx(fg, bg);		/* FƔwiFݒ */

	return 0;
}
